<script lang="ts">
	import Button from '$lib/components/Button.svelte';
	import ComputerSection from '$lib/components/ComputerSection.svelte';
	import PlayerSection from '$lib/components/PlayerSection.svelte';
	import type {
		Choice,
		Result,
		OpponentType,
		Game,
		User,
		Player
	} from '$lib/domains/RPS.type';
	import { spring } from 'svelte/motion';
	import { fade } from 'svelte/transition';
	import type { Socket } from 'socket.io-client';
	import { onMount } from 'svelte';
	import { getSocket } from '$lib/services/socket';

	export let game: Game;
	export let user: User;

	let socket: Socket | null = null;

	onMount(() => {
		socket = getSocket();
	});

	const displayedPlayerScore = spring();
	const displayedOpponentScore = spring();

	let playerChoice: Choice = getPlayer().choice;
	let opponentChoice: Choice = getOpponent().choice;
	let playerScore: number = getPlayer().score;
	let opponentScore: number = getOpponent().score;
	let result: Result = getResult();
	let userWaiting = false;

	$: if (game) {
		playerChoice = getPlayer().choice;
		opponentChoice = getOpponent().choice;
		playerScore = getPlayer().score;
		opponentScore = getOpponent().score;
		result = getResult();
	}

	$: displayedPlayerScore.set(playerScore);
	$: displayedOpponentScore.set(opponentScore);
	$: offsetPlayer = $displayedPlayerScore % 1;
	$: offsetOpponent = $displayedOpponentScore % 1;

	function getPlayer(): Player {
		const player = game.players.find((player) => player.id === user.id);
		if (!player) throw new Error('Player not found');
		return player;
	}
	function getOpponent(): Player {
		const opponent = game.players.find((player) => player.id !== user.id);
		if (!opponent) throw new Error('Opponent not found');
		return opponent;
	}

	function getResult(): Result {
		if (!game.result) {
			return null
		}
		if (game.result === getPlayer().id) {
			return 'win'
		}
		if (game.result === getOpponent().id) {
			return 'lose'
		}
		return 'draw';
	}

	function handleContinue() {
		socket?.emit("continue")
	}

	function handleReset() {
		socket?.emit("reset")
	}
</script>

<section class="container">
	<div class="score">
		<p>Score</p>
		<div class="score-flex">
			<div class="counter-viewport">
				<div
					class="counter-digits color-opponent"
					style="transform: translate(0, {100 * offsetOpponent}%)"
				>
					<span class="hidden" aria-hidden="true">
						{Math.floor($displayedOpponentScore + 1)}
					</span>
					<span>
						{Math.floor($displayedOpponentScore)}
					</span>
				</div>
			</div>
			-
			<div class="counter-viewport">
				<div
					class="counter-digits color-player"
					style="transform: translate(0, {100 * offsetPlayer}%)"
				>
					<span class="hidden" aria-hidden="true">
						{Math.floor($displayedPlayerScore + 1)}
					</span>
					<span>
						{Math.floor($displayedPlayerScore)}
					</span>
				</div>
			</div>
		</div>
	</div>
	<section class={`opponent-choice ${result ? result : ''}`}>
		<h2 class="color-opponent">{getOpponent().name}</h2>
		<ComputerSection bind:computerChoice={opponentChoice} />
	</section>
	<div class="separator">
		<span class={`result ${result}`}>{result ? result : 'VS'}</span>
	</div>
	<section class={`player-choice ${result ? result : ''}`}>
		<h2 class="color-player">{user.name}</h2>
		<PlayerSection bind:playerChoice {userWaiting} />
	</section>
	{#if result && getPlayer().role === "host"}
		<div transition:fade={{ duration: 200 }} class="button-container">
			<Button variant="outlined" on:click={handleReset}>Reset</Button>
			<Button on:click={handleContinue}>Continue</Button>
		</div>
	{/if}
</section>

<style>
	section.container {
		--color-player: #48dbfb;
		--color-opponent: #ff6b6b;

		flex: 1;
		display: flex;
		flex-direction: column;
		gap: 6vh;
	}

	.score {
		display: flex;
		flex-direction: column;
		font-size: 1.5rem;
		align-items: center;
	}
	.score p {
		font-size: 1.7rem;
		font-weight: bold;
	}

	.score-flex {
		display: flex;
		align-items: center;
		justify-content: center;
		gap: 1rem;
	}
	.color-player {
		color: var(--color-player);
	}
	.color-opponent {
		color: var(--color-opponent);
	}

	section h2 {
		text-align: center;
		margin-bottom: 1rem;
	}

	.separator {
		position: relative;
		background: var(--color-text);
		height: 1px;
	}
	.separator .result {
		z-index: 1;
		position: absolute;
		top: 50%;
		left: 50%;
		transform: translateX(-50%) translateY(-50%);

		display: flex;
		align-items: center;
		justify-content: center;
		width: 4rem;

		background: var(--color-text);
		padding: 0.3rem 0.5rem;
		font-size: 1.2rem;
		border-radius: 10rem;
		color: var(--color-bg-1);
	}
	.separator .result.win {
		background: var(--color-player);
		color: var(--color-bg-1);
	}
	.separator .result.lose {
		background: var(--color-opponent);
		color: var(--color-bg-1);
	}

	.button-container {
		display: flex;
		justify-content: center;
		gap: 1rem;
	}

	.counter-viewport {
		width: 2em;
		height: 2em;
		overflow: hidden;
		text-align: center;
		position: relative;
	}

	.counter-viewport span {
		position: absolute;
		display: flex;
		width: 100%;
		height: 100%;
		font-weight: 400;
		font-size: 1.5rem;
		align-items: center;
		justify-content: center;
	}

	.counter-digits {
		position: absolute;
		width: 100%;
		height: 100%;
	}

	.hidden {
		top: -100%;
		user-select: none;
	}

	.player-choice.lose,
	.opponent-choice.win {
		animation: shake 0.2s ease-in-out;
	}
	.player-choice.win,
	.opponent-choice.lose {
		animation: grow 0.5s ease-in-out;
	}

	@keyframes shake {
		0% {
			transform: translateX(-10px);
		}
		50% {
			transform: translateX(10px);
		}
		100% {
			transform: translateX(-10px);
		}
	}
	@keyframes grow {
		0% {
			transform: scale(1);
		}
		50% {
			transform: scale(1.05);
		}
		100% {
			transform: scale(1);
		}
	}
</style>
